(function() {
  var FractusBuild, VENDOR, browserify, build, bundle, color, exec, fs, nib, path, stylus, _;

  fs = require('fs');

  path = require('path');

  exec = require('child_process').exec;

  stylus = require('stylus');

  browserify = require('browserify');

  nib = require('nib');

  _ = require('underscore');

  bundle = require('stratus-bundle');

  color = require('stratus-color');

  VENDOR = "" + __dirname + "/../vendor";

  module.exports = build = function(options) {
    return new FractusBuild(options);
  };

  build.path = "" + __dirname + "/../styl";

  FractusBuild = (function() {

    function FractusBuild(options) {
      var lang, _i, _len, _ref;
      this.langs = options.langs, this.theme = options.theme, this.jquery = options.jquery, this.underscore = options.underscore;
      this.bundles = {};
      _ref = this.langs.slice();
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        lang = _ref[_i];
        this.addLang(lang);
      }
      this.theme || (this.theme = "Idlefingers");
      if (this.jquery == null) this.jquery = true;
      if (this.underscore == null) this.underscore = true;
    }

    FractusBuild.prototype.addLang = function(lang) {
      var langBundle, sublang, _base, _i, _len, _ref;
      if ((_base = this.bundles)[lang] == null) _base[lang] = bundle(lang);
      langBundle = this.bundles[lang];
      if (langBundle["extends"]) this.addLang(langBundle["extends"]);
      _ref = langBundle.require || [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        sublang = _ref[_i];
        this.addLang(sublang);
      }
      if (!~this.langs.indexOf(lang)) this.langs.push(lang);
    };

    FractusBuild.prototype.js = function(file, callback) {
      var browserBundle, bund, bundleString, jsCode, lang, _i, _len, _ref;
      jsCode = "window.fractusBundles = {};";
      if (this.jquery) {
        jsCode += fs.readFileSync("" + VENDOR + "/jquery-1.7.1.min.js").toString();
      }
      if (this.underscore) {
        jsCode += fs.readFileSync(require.resolve("underscore")).toString();
      }
      browserBundle = browserify();
      browserBundle.require(require.resolve("./"));
      jsCode += browserBundle.bundle();
      jsCode += "require.modules.fractus = require.modules[\"/index.js\"];\n!function() {\n  var color = require(\"/node_modules/stratus-color/lib/highlight.js\");";
      _ref = this.langs;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        lang = _ref[_i];
        bund = this.bundles[lang].toJSONSync();
        bundleString = JSON.stringify(bund);
        jsCode += "window.fractusBundles['" + lang + "'] = " + bundleString + ";\ncolor.addScopes(window.fractusBundles['" + lang + "'].syntax);";
      }
      jsCode += "}()";
      if (file) {
        return fs.writeFile(file, jsCode, function(err) {
          return callback(err);
        });
      } else {
        return jsCode;
      }
    };

    FractusBuild.prototype.css = function(file, callback) {
      var cssCode, styl, _ref;
      if (file && !callback) {
        _ref = [file, callback], callback = _ref[0], file = _ref[1];
      }
      cssCode = color.css(this.theme, {
        root: "fractus",
        cursor: "fractus-cursor",
        selection: "fractus-selection"
      });
      cssCode += "\n";
      styl = fs.readFileSync("" + __dirname + "/../styl/fractus.styl").toString();
      return stylus(styl).set("filename", "fractus.styl").include(nib.path).render(function(err, css) {
        if (!err) cssCode += css;
        if (file) {
          return fs.writeFile(file, cssCode, function(err) {
            return callback(err);
          });
        } else {
          return callback(err, cssCode);
        }
      });
    };

    return FractusBuild;

  })();

}).call(this);
