(function() {
  var HomeHome, ct;

  module.exports = {
    Right: function(edt) {
      edt.cursor.moveRight();
      return ct(edt);
    },
    "Control-Right": function(edt) {
      edt.cursor.moveToNextWord();
      return ct(edt);
    },
    Up: function(edt) {
      edt.cursor.moveUp();
      return ct(edt);
    },
    Left: function(edt) {
      edt.cursor.moveLeft();
      return ct(edt);
    },
    "Control-Left": function(edt) {
      edt.cursor.moveToPrevWord();
      return ct(edt);
    },
    Down: function(edt) {
      edt.cursor.moveDown();
      return ct(edt);
    },
    Home: function(edt) {
      HomeHome(edt);
      return ct(edt);
    },
    End: function(edt) {
      edt.cursor.moveToLineEnd();
      return ct(edt);
    },
    "Control-Home": function(edt) {
      edt.cursor.moveToDocBegin();
      return ct(edt);
    },
    "Control-End": function(edt) {
      edt.cursor.moveToDocEnd();
      return ct(edt);
    },
    PageUp: function(edt) {
      edt.cursor.pageUp();
      return ct(edt);
    },
    PageDown: function(edt) {
      edt.cursor.pageDown();
      return ct(edt);
    },
    "Control-a": function(edt) {
      edt.cursor.selectAll();
      return ct(edt);
    },
    "Shift-Right": function(edt) {
      edt.cursor.selectRight();
      return ct(edt);
    },
    "Control-Shift-Right": function(edt) {
      edt.cursor.selectToNextWord();
      return ct(edt);
    },
    "Shift-Up": function(edt) {
      edt.cursor.selectUp();
      return ct(edt);
    },
    "Shift-Left": function(edt) {
      edt.cursor.selectLeft();
      return ct(edt);
    },
    "Control-Shift-Left": function(edt) {
      edt.cursor.selectToPrevWord();
      return ct(edt);
    },
    "Shift-Down": function(edt) {
      edt.cursor.selectDown();
      return ct(edt);
    },
    "Shift-Home": function(edt) {
      HomeHome(edt, "select");
      return ct(edt);
    },
    "Shift-End": function(edt) {
      edt.cursor.selectToLineEnd();
      return ct(edt);
    },
    "Control-Shift-Home": function(edt) {
      edt.cursor.selectToDocBegin();
      return ct(edt);
    },
    "Control-Shift-End": function(edt) {
      edt.cursor.selectToDocEnd();
      return ct(edt);
    },
    "Shift-PageUp": function(edt) {},
    "Shift-PageDown": function(edt) {},
    Backspace: function(edt) {
      return edt.cursor.deleteBack();
    },
    Delete: function(edt) {
      return edt.cursor.deleteForward();
    },
    "Control-Backspace": function(edt) {
      edt.cursor.deleteWordBack();
      return ct(edt);
    },
    "Control-Delete": function(edt) {
      edt.cursor.deleteWordForward();
      return ct(edt);
    },
    "Control-d": function(edt) {
      edt.cursor.deleteRows();
      return ct(edt);
    },
    "Alt-Up": function(edt) {
      return edt.cursor.shiftLinesUp();
    },
    "Alt-Down": function(edt) {
      return edt.cursor.shiftLinesDown();
    },
    "Control-z": function(edt) {
      return edt.buffer.undo();
    },
    "Control-Shift-z": function(edt) {
      return edt.buffer.redo();
    },
    "\t": function(edt) {
      return edt.cursor.indent(edt.tab);
    },
    "Shift-\t": function(edt) {
      return edt.cursor.outdent(edt.tab);
    },
    otherwise: function(edt, key) {
      if (key.length === 1) {
        edt.cursor.insert(key);
        if (/\s/.test(key)) ct(edt);
        return false;
      } else {
        return true;
      }
    }
  };

  ct = function(edt) {
    return edt.buffer.commitTransaction();
  };

  HomeHome = function(edt, method) {
    var point, whitespace;
    if (method == null) method = "move";
    point = edt.cursor.point || edt.cursor.region.end;
    if (point.col === 0) {
      whitespace = /^\s*/.exec(edt.buffer.text(point.row));
      return edt.cursor["" + method + "To"](null, whitespace[0].length);
    } else {
      return edt.cursor["" + method + "ToLineBegin"]();
    }
  };

}).call(this);
