(function() {
  var CursorView, EventEmitter, Input, Point, Region, View, char, keyboard, _ref,
    __hasProp = Object.prototype.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; };

  EventEmitter = require('events').EventEmitter;

  _ref = require('./buffer'), Point = _ref.Point, Region = _ref.Region;

  keyboard = require('stratus-keyboard');

  char = _.memoize(function(c) {
    var $char, $div, size;
    if (c == null) c = "X";
    $div = $("<div class='fractus'/>").css({
      height: "auto",
      position: "absolute",
      width: "auto"
    });
    $char = $("<ul class='fractus-lines'><li><span>" + c + "</span></li></ul>");
    $char = $char.find("span");
    $div.append($char).appendTo("body");
    size = {
      height: $char.height(),
      width: $char.width()
    };
    $div.remove();
    return size;
  });

  View = (function(_super) {

    __extends(View, _super);

    View.sizeOf = char;

    function View($el, buffer, layout, cursor, options) {
      var charSize, ignoreClicks,
        _this = this;
      this.$el = $el;
      this.buffer = buffer;
      this.layout = layout;
      this.cursor = cursor;
      this.scrollwheel = options.scrollwheel;
      charSize = char();
      this.colWidth = charSize.width;
      this.lineHeight = charSize.height;
      this.cursorView = new CursorView(this, this.cursor);
      this.input = new Input();
      this.$el.addClass("fractus").append(this.input.$el).append(this.$scrollView = $("<div/>", {
        "class": "fractus-scrollview"
      })).append(this.$lines = $("<ul/>", {
        "class": "fractus-lines"
      })).append(this.$gutter = $("<div/>", {
        "class": "fractus-gutter"
      }));
      this.$yScroller = $("<div/>", {
        "class": "fractus-scroller-y"
      });
      this.$scrollView.append(this.$yScroller);
      this.$scrollView.append(this.cursorView.$el);
      this.onResize();
      this.layout.on("scrollY", function(scrollTop) {
        return _this.$scrollView.scrollTop(scrollTop);
      });
      this.layout.on("render", function(html) {
        return _this.onRender(html);
      });
      this.layout.on("render:line:change", function(data) {
        return _this.onLineChange(data);
      });
      this.layout.on("render:line:insert", function(data) {
        return _this.onLineInsert(data);
      });
      this.layout.on("render:line:delete", function(data) {
        return _this.onLineDelete(data);
      });
      this.layout.on("gutter:renumber", function(range) {
        return _this.updateLineNumbers(range.begin, range.end);
      });
      this.layout.on("gutter:resize", function(width) {
        return _this.resizeGutter(width);
      });
      this.layout.on("change:height", function(height) {
        return _this.$yScroller.height(height);
      });
      this.$el.on("mousewheel", function(event) {
        return _this.onMousewheel(event);
      });
      this.$lines.on("mousedown", function(event) {
        return _this.onMousedown(event);
      });
      this.$lines.on("mousemove", function(event) {
        return _this.onMousemove(event);
      });
      this.$lines.on("mouseup", function(event) {
        return _this.onMouseup(event);
      });
      this.$scrollView.on("scroll", function(event) {
        return _this.onScrollbar(event);
      });
      ignoreClicks = ".fractus-selection, .hi-emphasize, .hi-search";
      this.$el.on("mousedown", ignoreClicks, function(event) {
        return _this.onMousedown(event);
      });
      this.$el.on("mousemove", ignoreClicks, function(event) {
        return _this.onMousemove(event);
      });
      this.$el.on("mouseup", ignoreClicks, function(event) {
        return _this.onMouseup(event);
      });
      $("body").on("mouseup", function() {
        _this.dragging = false;
      });
      this.input.on("copy", function(event) {
        return _this.onCopy(event);
      });
      this.input.on("cut", function(event) {
        return _this.onCut(event);
      });
      this.input.on("paste", function(event) {
        return _this.onPaste(event);
      });
      this.layout.ready();
      this.onScroll();
      this.cursorView.onMove();
      this.focus();
      this.input.$el.on("focus", function() {
        return _this.emit("focus");
      });
      this.input.$el.on("blur", function() {
        return _this.emit("blur");
      });
    }

    View.prototype.focus = function() {
      var _this = this;
      this.emit("focus");
      this.layout.lockScroll();
      this.input.focus();
      return _.defer(function() {
        return _this.layout.unlockScroll();
      });
    };

    View.prototype.onResize = function() {
      this.layout.setHeight(this.$lines.height());
      return this.layout.setWidth(this.$lines.width());
    };

    View.prototype.onScroll = function(event) {
      /*newScroll  = @$el.scrollTop() + 1
      if @layout.scrollLock
        @$el.scrollTop @scrollTop
        return false
      return false if newScroll == @scrollTop - 1
      @scrollTop = newScroll
      row        = Math.floor @scrollTop / @layout.sizeOf().height
      
      # Update the gutter and lines.
      coords = {top: @scrollTop - 1}
      @$gutter.css coords
      @$lines.css  coords
      
      # Oh, snap ???
      #@$el.scrollTop row * @layout.sizeOf().height
      @layout.scrollTo row
      */      return true;
    };

    View.prototype.onMousewheel = function(event) {
      var mod, wheelDelta;
      wheelDelta = event.originalEvent.wheelDelta;
      mod = wheelDelta < 1 ? -1 : 1;
      return this.layout.scrollTo(this.layout.topRow - mod * this.scrollwheel);
    };

    View.prototype.onScrollbar = function(event) {
      var newScroll, row;
      newScroll = this.$scrollView.scrollTop();
      row = Math.floor(newScroll / this.layout.sizeOf().height);
      this.layout.scrollTo(row);
      return this.$scrollView.scrollTop(this.layout.scrollTop(row));
    };

    View.prototype.onMousedown = function(event) {
      var point;
      if (event.button !== 0) return;
      point = this.eventToPoint(event);
      point.round();
      this.clickType = this.multiClick(point);
      this.dragging = true;
      switch (this.clickType) {
        case 1:
          this.on1Click(point, event.shiftKey);
          break;
        case 2:
          this.on2Click(point, event.shiftKey);
          break;
        case 3:
          this.on3Click(point, event.shiftKey);
      }
      return false;
    };

    View.prototype.on1Click = function(point, shift) {
      this.buffer.commitTransaction();
      this.focus();
      if (shift) {
        return this.cursor.selectTo(point);
      } else {
        this.cursorView.clearSelection();
        return this.cursor.moveTo(point);
      }
    };

    View.prototype.on2Click = function(point, shift) {
      this.anchorWord = this.buffer.wordAt(point);
      return this.cursor.select(this.anchorWord);
    };

    View.prototype.on3Click = function(point, shift) {
      var row;
      row = point.row;
      this.beginRow = row;
      return this.cursor.selectRow(row);
    };

    View.prototype.onMousemove = function(event) {
      var point, toWord;
      if (!this.dragging) return;
      point = this.eventToPoint(event);
      point.round();
      switch (this.clickType) {
        case 1:
          this.cursor.selectTo(point);
          break;
        case 2:
          toWord = this.buffer.wordAt(point);
          if (!toWord) break;
          if (toWord.end.isBefore(this.cursor.region.ordered().end)) {
            this.cursor.region.end.moveTo(toWord.begin);
            this.cursor.region.begin.moveTo(this.anchorWord.end);
          } else if (this.cursor.region.ordered().begin.isBefore(toWord.begin)) {
            this.cursor.region.begin.moveTo(this.anchorWord.begin);
            this.cursor.region.end.moveTo(toWord.end);
          }
          break;
        case 3:
          this.cursor.selectRows(this.beginRow, point.row);
      }
      return false;
    };

    View.prototype.onMouseup = function(event) {};

    View.prototype.multiClick = function(point) {
      var col, row,
        _this = this;
      row = point.row, col = point.col;
      this._multi || (this._multi = 0);
      this._multi++;
      if (this._multiRow !== row || this._multiCol !== col) {
        this._multiRow = row;
        this._multiCol = col;
        this._multi = 1;
      }
      setTimeout(function() {
        return _this._multi--;
      }, 500);
      if (this._multi > 3) this._multi = 1;
      return this._multi;
    };

    View.prototype.updateLineNumbers = _.debounce(function(beginRow, endRow) {
      var html, rows, _i, _ref2, _ref3, _results;
      rows = (function() {
        _results = [];
        for (var _i = _ref2 = beginRow + 1, _ref3 = endRow + 1; _ref2 <= _ref3 ? _i <= _ref3 : _i >= _ref3; _ref2 <= _ref3 ? _i++ : _i--){ _results.push(_i); }
        return _results;
      }).apply(this);
      html = "<span>" + (rows.join("</span><span>")) + "</span>";
      this.$gutter.html(html);
      return this.highlightCurrentLines();
    }, 10);

    View.prototype.resizeGutter = _.debounce(function(width) {
      this.$gutter.width(width);
      return this.$lines.css({
        left: width
      });
    }, 100);

    View.prototype.highlightCurrentLines = function() {
      var begin, end, row, _ref2, _ref3, _ref4, _results;
      this.clearCurrentLines();
      if (this.cursor.point) {
        row = this.cursor.point.row;
        return this.currentLine(row);
      } else if (this.cursor.region) {
        _ref2 = this.cursor.region.ordered(), begin = _ref2.begin, end = _ref2.end;
        if (begin.row === end.row) {
          return this.currentLine(begin.row);
        } else {
          this.currentLine(begin.row, "current-top");
          this.currentLine(end.row, "current-bottom");
          _results = [];
          for (row = _ref3 = begin.row, _ref4 = end.row; _ref3 <= _ref4 ? row <= _ref4 : row >= _ref4; _ref3 <= _ref4 ? row++ : row--) {
            _results.push(this.currentLine(row, "current-middle"));
          }
          return _results;
        }
      }
    };

    View.prototype.currentLine = function(row, type) {
      var _ref2;
      if (type == null) type = "current";
      return (_ref2 = this.rowToGutterEl(row)) != null ? _ref2.addClass(type) : void 0;
    };

    View.prototype.clearCurrentLines = function() {
      return this.$gutter.children(".current-top, .current-middle, .current-bottom, .current").removeClass("current-top current-middle current-bottom current");
    };

    View.prototype.onLineChange = function(data) {
      var html, row;
      row = data.row, html = data.html;
      return this.rowToEl(row).replaceWith(html);
    };

    View.prototype.onLineInsert = function(data) {
      var html, row;
      row = data.row, html = data.html;
      if (row > 0) {
        return this.rowToEl(row - 1).after(html);
      } else {
        return this.rowToEl(0).before(html);
      }
    };

    View.prototype.onLineDelete = function(data) {
      var html, row;
      row = data.row, html = data.html;
      this.rowToEl(row).remove();
      if (html) return this.$lines.append(html);
    };

    View.prototype.onRender = function(html) {
      return this.$lines.html(html);
    };

    View.prototype.rowToEl = function(row) {
      var $line, rowIndex;
      rowIndex = row - this.layout.topRow + 1;
      $line = this.$lines.children(":nth-child(" + rowIndex + ")");
      if ($line.length) {
        return $line;
      } else {
        return null;
      }
    };

    View.prototype.rowToGutterEl = function(row) {
      var $num, rowIndex;
      if (row == null) return null;
      rowIndex = row - this.layout.topRow + 1;
      $num = this.$gutter.children("span:nth-child(" + rowIndex + ")");
      if ($num.length) {
        return $num;
      } else {
        return null;
      }
    };

    View.prototype.onCopy = function() {
      this.buffer.commitTransaction();
      this.input.setText(this.cursor.text());
      return true;
    };

    View.prototype.onCut = function() {
      this.buffer.commitTransaction();
      this.input.setText(this.cursor.text());
      this.cursor.deleteSelection();
      return true;
    };

    View.prototype.onPaste = function(event) {
      var clipboardText,
        _this = this;
      this.buffer.commitTransaction();
      clipboardText = event.originalEvent.clipboardData.getData("text/plain");
      this.layout.lockScroll();
      this.cursor.insert(clipboardText);
      return setTimeout(function() {
        return _this.layout.unlockScroll();
      }, 50);
    };

    View.prototype.eventToPoint = function(event) {
      var offsetX, offsetY;
      offsetX = event.pageX - this.$lines.offset().left;
      offsetY = event.pageY - this.$lines.offset().top;
      return this.layout.coordsToPoint(offsetY, offsetX);
    };

    return View;

  })(EventEmitter);

  CursorView = (function() {

    function CursorView(view, cursor) {
      var _this = this;
      this.view = view;
      this.cursor = cursor;
      this.layout = this.view.layout;
      this.$el = $("<div/>", {
        "class": "fractus-cursor"
      });
      this.$el.height(this.view.lineHeight);
      this.cursor.on("move", function() {
        return _this.onMove();
      });
    }

    CursorView.prototype.onMove = function() {
      var left, top, _ref2, _ref3,
        _this = this;
      this.clearSelection();
      if (this.cursor.point) {
        _ref2 = this.layout.pointToCoords(this.cursor.point), top = _ref2[0], left = _ref2[1];
        this.$el.css({
          top: top,
          left: left
        });
      } else {
        this.renderSelection();
        _ref3 = this.layout.pointToCoords(this.cursor.region.end), top = _ref3[0], left = _ref3[1];
        this.$el.css({
          top: top,
          left: left
        });
      }
      this.view.highlightCurrentLines();
      return setTimeout(function() {
        return _this.scrollTo();
      }, 0);
    };

    CursorView.prototype.scrollTo = function() {
      var point;
      point = this.cursor.point || this.cursor.region.end;
      if (this.layout.isTooFarDown(point)) {
        return this.layout.scrollBottom(point.row);
      } else if (this.layout.isTooFarUp(point)) {
        return this.layout.scrollTo(point.row);
      }
    };

    CursorView.prototype.renderSelection = function() {
      var begin, end, _ref2;
      _ref2 = this.cursor.region.ordered(), begin = _ref2.begin, end = _ref2.end;
      if (!this.rect1(begin, end)) return;
      if (!this.rect3(begin, end)) return;
      return this.rect2(begin, end);
    };

    CursorView.prototype.$rect = function() {
      return $("<div/>", {
        "class": "fractus-selection"
      });
    };

    CursorView.prototype.rect1 = function(begin, end) {
      var endLeft, left, top, ___, _ref2, _ref3;
      this.$rect1 = this.$rect();
      _ref2 = this.layout.pointToCoords(begin), top = _ref2[0], left = _ref2[1];
      this.$rect1.appendTo(this.view.$scrollView).css({
        height: this.view.lineHeight,
        top: top,
        left: left
      });
      if (begin.row === end.row) {
        _ref3 = this.layout.pointToCoords(end), ___ = _ref3[0], endLeft = _ref3[1];
        this.$rect1.css({
          width: endLeft - left
        });
        return false;
      } else {
        this.$rect1.css({
          right: 0
        });
        return true;
      }
    };

    CursorView.prototype.rect2 = function(begin, end) {
      var beginLeft, beginTop, endLeft, endTop, _ref2, _ref3;
      this.$rect2 = this.$rect();
      _ref2 = this.layout.pointToCoords(begin), beginTop = _ref2[0], beginLeft = _ref2[1];
      _ref3 = this.layout.pointToCoords(end), endTop = _ref3[0], endLeft = _ref3[1];
      return this.$rect2.appendTo(this.view.$scrollView).css({
        top: beginTop + this.view.lineHeight,
        left: this.view.$gutter.width(),
        right: 0,
        height: endTop - beginTop - this.view.lineHeight
      });
    };

    CursorView.prototype.rect3 = function(begin, end) {
      var left, top, _ref2;
      this.$rect3 = this.$rect();
      _ref2 = this.layout.pointToCoords(end), top = _ref2[0], left = _ref2[1];
      this.$rect3.appendTo(this.view.$scrollView).css({
        top: top,
        width: left - this.view.$gutter.width(),
        left: this.view.$gutter.width()
      });
      if (begin.row + 1 === end.row) {
        this.$rect3.css({
          height: this.view.lineHeight
        });
        return false;
      } else {
        return true;
      }
    };

    CursorView.prototype.clearSelection = function() {
      var _ref2, _ref3, _ref4;
      if ((_ref2 = this.$rect1) != null) _ref2.remove();
      if ((_ref3 = this.$rect3) != null) _ref3.remove();
      return (_ref4 = this.$rect2) != null ? _ref4.remove() : void 0;
    };

    return CursorView;

  })();

  Input = (function(_super) {

    __extends(Input, _super);

    function Input() {
      var _this = this;
      this.$el = $("<textarea></textarea>");
      keyboard.focus(this.$el, "fractus");
      this.$el.on("copy", function(event) {
        return _this.emit("copy", event);
      });
      this.$el.on("cut", function(event) {
        return _this.emit("cut", event);
      });
      this.$el.on("paste", function(event) {
        return _this.emit("paste", event);
      });
    }

    Input.prototype.focus = function() {
      return this.$el.focus();
    };

    Input.prototype.setText = function(text) {
      this.$el.val(text);
      return this.$el[0].select();
    };

    return Input;

  })(EventEmitter);

  module.exports = {
    View: View
  };

}).call(this);
